<template>
  <dashboard-layout title="empty">
    <div class="container-fluid">
      <div class="auth-form mx-auto col-sm-6">
        <h2 class="auth-title mt-3 mb-4">Inscription</h2>
        <br>
        <!--  <h2 class="auth-title  mb-4">Position {{position.lng}} {{position.lat}}</h2> -->
        <div class="alert alert-danger" v-if="errorMessage">
          {{ errorMessage }}
        </div>
        <!-- <div class="mx-auto"><button class="btn btn-info m-5" @click="sendVerificationMail">go</button></div> -->

        <form @submit="register">
          <div class="row">
            <div class="col-12 form-group mb-5">
              <label> Vous êtes </label>
              <select class="form-control" v-model="newAdmin.role">
                <option value="agence">Une Agence Immobilière </option>
                <option value="client">Un client</option>
              </select>
            </div>
            <!-- agence -->
            <div v-if="newAdmin.role == 'agence'" class="col-6 form-group">
              <label>Nom de l'agence</label>
              <input
                type="text"
                class="form-control"
                v-model="newAdmin.name"
                placeholder="Nom"
              />
            </div>
            <!-- client -->
            <div v-if="newAdmin.role == 'client'" class="col-6 form-group">
              <label>Nom et Prénom(s)</label>
              <input
                type="text"
                class="form-control"
                v-model="newAdmin.fullname"
                placeholder="Nom"
              />
            </div>
            
            <div class="col-6 form-group">
              <label>Téléphone</label>
              <input
                type="text"
                class="form-control"
                v-model="newAdmin.phone"
                placeholder="Nom"
              />
            </div>
            <div class="col-6 form-group">
              <label>Mot de passe</label>
              <input
                type="password"
                class="form-control"
                v-model="newAdmin.password"
                placeholder="Mot de passe"
              />
            </div>
            <div class="col-6 form-group">
              <label> Confirmer le Mot de passe</label>
              <input
                type="password"
                class="form-control"
                v-model="confpassword"
                placeholder="Confirmer mot de passe"
              />
            </div>
            
          </div>
          <div class="form-group col-sm-4 mx-auto mt-4">
            <input
              type="submit"
              class="btn btn-light btn-block"
              value="Valider"
            />
          </div>
        </form>

        <div class="form-group text-center">
          <router-link class="text-manote" to="/login"
            >Vous avez deja un compte ? <br />
            Connectez vous !</router-link
          >
        </div>
      </div>
    </div>
  </dashboard-layout>
</template>

<script>
import Pays from "./users/country";

export default {
  name: "Login",
  data() {
    return {
      newAdmin: {
        role:'agence',
        address : {
          longitude: 0,
          latitude: 0
        }
      },
      confpassword: "",
      errorMessage: "",
      welcomeMail: {},
      position: { },

    };
  },
  created() {
    //do we support geolocation
    if(!("geolocation" in navigator)) {
      this.errorStr = 'La géolocalisation n\'est ps disponible.';
      return;
    }

    this.gettingLocation = true;
    // get position
    navigator.geolocation.getCurrentPosition(pos => {
      this.gettingLocation = false;
      this.location = pos;
    }, err => {
      this.gettingLocation = false;
      this.errorStr = err.message;
    })
  },
  mounted() {
    this.geolocate();
  },
  methods: {
    register(e) {
      e.preventDefault();
      if (this.newAdmin.password == this.confpassword) {
        if (this.newAdmin.role =='client'){
          this.newAdmin.address.longitude = this.position.lat;
          this.newAdmin.address.latitude = this.position.lng;
        }
        if(this.newAdmin.role == 'client'){
          this.newAdmin.active = true;
        }
        console.log("datas",this.newAdmin);
        this.$service.createAdmin(this.newAdmin, (err, data) => {
          if (err) {
            this.errorMessage = err.data && err.data.message;
            console.log("Error", err.data);
            return;
          }


          
          let datas = {
            admin : data.admin.id,
            message: 'register',
            date: new Date(),
            position : this.center,
          }
          this.$service.create("historiques", datas, (err, data) => {
            if (err) {
              this.errorMessage = err.data && err.data.message;
              return;
            }
            this.$swal.fire("Compte créé !!!", "", "success").then(() => {
              this.$router.push({ path: "/login" });
            });    
          });
        
        });
      } else {
        this.errorMessage = "Confirmation mot de passe échouée.";
      }
    },
    geolocate: function() {
      navigator.geolocation.getCurrentPosition(position => {
        this.position = {
          lat: position.coords.latitude,
          lng: position.coords.longitude,
        };
      });
    },



    sendVerificationMail() {
      // this.welcomeMail.email = "bchryzal@gmail.com";
      // this.welcomeMail.name = "Daven Dupont";
      this.$service.verificationMail(this.welcomeMail, (err, data) => {
        if (err) {
          return console.log("Verification Mail not send => ", err);
        }
        //console.log("Sender Mail Data :", data);
      });
    },
    login() {
      let user = {
        email: this.admin.email,
        password: this.admin.password,
      };
      this.$service.login(user, (err, data) => {
        if (err) {
          return console.log("Login not doing => ", err);
        }

        console.log("login success ", data);

        this.update(data.admin._id, data.token);
      });
    },
    update(idUser, tokenUser) {
      let user = {
        // id: idUser,
        active: true,
      };

      this.$service.putWithToken(
        "admins/" + idUser,
        user,
        tokenUser,
        (err, data) => {
          if (err) {
            return console.log("Update not doing => ", err);
          }

          console.log("User active successfuled update ", data);

          this.admin = {};
        }
      );
    },
  },
};
</script>
